%BAR_EX   Extended bar graph.
%    BAR(X,Y) draws the columns of the M-by-N matrix Y as M groups of N
%    vertical bars.  The vector X must be monotonically increasing or
%    decreasing, and must be one longer than Y. X contains the limits for
%    the bins, Y its values.

% Copyright Cris Luengo, December 2000.
% Based on BAR by The MathWorks:
%    C.B Moler 2-06-86
%    Modified 24-Dec-88, 2-Jan-92 LS.
%    Modified 8-5-91, 9-22-94 by cmt; 8-9-95 WSun.
%    Copyright (c) 1984-98 by The MathWorks, Inc.
%    $Revision: 5.29 $  $Date: 1998/05/19 19:37:04 $

function bar_ex(x,y,edgec,facec)

if nargin<2 | length(y)~=length(x)-1
   error('Invalid input.')
end
if nargin < 4
   facec = [0.75,0.75,0.75];
   if nargin < 3
      edgec = 'k';
   end
end

cax = newplot;
next = lower(get(cax,'NextPlot'));
hold_state = ishold;
h = [];
for ii=1:length(y)
   v = [x(ii),y(ii);x(ii+1),y(ii);x(ii+1),0;x(ii),0];
   h = [h,patch('vertices',v,'faces',[1,2,3,4],...
        'FaceColor',facec,'EdgeColor',edgec)];
end
if length(h)==1, set(cax,'clim',[1 2]), end
if ~hold_state,
   % Set ticks if less than 16 integers
   set(cax,'xtick',x)
   hold off, view(2), set(cax,'NextPlot',next);
   set(cax,'Layer','Bottom','box','on')
end
